#!/bin/sh
# $Id: update-countries.sh,v 1.2 2006/09/16 12:25:53 maxim Exp $
#
# updates Geo-IP DB from MaxMind and converts to own format;
# 0W-httpd must be configured with country support to handle this list:
# ./configure --with-country
#
# wget is required
#


EXEC_DIR=`dirname $0`
CUR_DIR=`pwd`
case "$EXEC_DIR" in
    /*) DIR="$EXEC_DIR";;
    *) DIR="$CUR_DIR/$EXEC_DIR";;
esac

cd $DIR/../conf || exit

echo Getting &&
wget -q -N http://www.maxmind.com/download/geoip/database/GeoIPCountryCSV.zip &&
echo Checking &&
(test ! -s countries.ips || test GeoIPCountryCSV.zip -nt countries.ips) &&
echo Unzipping &&
gzip -dc GeoIPCountryCSV.zip > GeoIPCountryWhois.csv &&
echo Converting &&
$DIR/convert-geoip < GeoIPCountryWhois.csv &&
echo Done &&
rm GeoIPCountryWhois.csv ||
echo Nope

echo Getting russian regions &&
wget -q -N http://0w.ru/httpd/conf/regions.ips &&
echo Done
