/* $Id: signames.c,v 1.2 2006/09/16 12:17:17 maxim Exp $
 *
 */

#include <signal.h>

#include "configure.h"

#include "signames.h"
#include "str.h"

static char* signames[32];
static char inited = 0;


char*
signame(int sig)
{
	if (!inited) {
		signames[SIGHUP] = "HUP";
		signames[SIGINT] = "INT";
		signames[SIGQUIT] = "QUIT";
		signames[SIGILL] = "ILL";
		signames[SIGABRT] = "ABRT";
		signames[SIGFPE] = "FPE";
		signames[SIGKILL] = "KILL";
		signames[SIGSEGV] = "SEGV";
		signames[SIGPIPE] = "PIPE";
		signames[SIGALRM] = "ALRM";
		signames[SIGTERM] = "TERM";
		signames[SIGUSR1] = "USR1";
		signames[SIGUSR2] = "USR2";
		signames[SIGCHLD] = "CHLD";
		signames[SIGCONT] = "CONT";
		signames[SIGSTOP] = "STOP";
		signames[SIGTSTP] = "TSTP";
		signames[SIGTTIN] = "TTIN";
		signames[SIGTTOU] = "TTOU";
		signames[SIGTRAP] = "TRAP";
		signames[SIGBUS] = "BUS";
		signames[SIGURG] = "URG";
		signames[SIGWINCH] = "WINCH";
		signames[SIGIO] = "IO";
		inited = 1;
	}
	if (0 < sig && sig < 32 && signames[sig]) return signames[sig];
	return "unknown";
}

