/* $Id: core.h,v 1.2 2006/09/16 12:17:17 maxim Exp $
 *
 */

#ifndef CORE_H
#define CORE_H

#include "configure.h"

#include "httpd.h"

enum {
	LISTENER = 1,
	REQUEST,
	PROXY_REQUEST
};

#ifdef STATUS
#undef STATUS
#endif

enum {
	LOCAL = 1,
	REDIRECT,
	PROXY,
	CGI,
	EMPTY,
	PIXEL,
	STORAGE,
	STATUS
};


enum {
	UNDEF,
	READ_REQUEST,
	KEEP_ALIVE,
	READ_HEADER,
	READ_POST,
	HANDLE_REQUEST,
	HANDLING,
	PREPARE_HEADER,
	WRITE_HEADER,
	WRITE_BODY,
	WRITE_CONTENT,
	WAIT_DATA,
	DONE,
	CLOSE,
	NOT_OK
};

extern FD* fds;
extern int maxFD;
extern int fdLimit;
extern int rtSignal;
extern char* methods[];
extern Buffer* currentBuffer;
extern Request* currentRequest;


time_t timerfc(char *s);
char work(int argc, char** argv);
Buffer* newBuffer(int size);
Buffer* freeBuffer(Buffer* buffer);
void http(Request* r);
char* unifyHostName(char* host);
int handleStatusRequest(Request* r);
char* addStringToBuffer(Request* r, char* string, int n);
void logRequest(Request* r);

#if MODEL == MODEL_KEVENT
void watchEvent(int fd, int filter, int flags, u_int fflags, int data);
#endif

#endif

