/* $Id: filters.c,v 1.2 2006/09/16 12:17:17 maxim Exp $
 *
 */

#include <string.h>
#include <stdio.h>

#include "configure.h"

#include "common/misc.h"
#include "httpd.h"

#if SUPPORT_FILTER

enum {
	STRIP_META_SEARCH = 1,
	STRIP_META_PREFIX,
};


void
filterStripMeta(Request* r, char flush)
{
	char* c;
	char* end;
	const char* prefix = "<meta";

	if (flush) {
		r->filtered += r->filter.pos;
		return;
	}

	c = r->content + r->filtered + r->filter.pos - r->offset;
	end = r->content + r->received - r->offset;

	for (; c < end; c++) {
		switch (r->filter.state) {
		case STRIP_META_SEARCH:
			while (*c != *prefix) {
				r->filtered++;
				if (++c == end) return;
			}
			r->filter.pos = 1;
			r->filter.state = STRIP_META_PREFIX;
			break;

		case STRIP_META_PREFIX:
			while (*c == prefix[r->filter.pos++]) {
				if (!prefix[r->filter.pos]) {
					r->content[r->filtered - r->offset + 1] = '!';
					break;
				}
				if (++c == end) return;
			}
			r->filtered += r->filter.pos;
			r->filter.state = STRIP_META_SEARCH;
			r->filter.pos = 0;
			break;
		}
	}
}
#endif
